;***************************************************************************
;* Const Def

.EQU	T0Freq=184		;220 @1.8432MHz = 50Hz
	                        ;184 @3.6864MHz = 50Hz
	                        ;184 @7.3728MHz = 100Hz
				;247 @7.3728MHz = 800Hz ~ 1.25ms


;***************************************************************************
;**  Timer0 Init		*****

InitTimer0:	LDI	R16,T0Freq
		OUT	TCNT0,R16
		LDI	R16,0b00000101
		OUT	TCCR0,R16	;TC0 Control Register
					;2:0 Clock Select
					; 000 -> Stop
					; 001 -> CK
					; 010 -> CK/8
					; 011 -> CK/64
					; 100 -> CK/256
					; 101 -> CK/1024
					; 110 -> External pin T0 falling edge
					; 111 -> External pin T0 risinrg edge
		ret


;***************************************************************************
;**  Timer1 Init		*****
;**  Init HW Timer1 & PWMA, PWMB 

InitTimer1:	clr	R16
		OUT	OCR1AH,R16
		OUT	OCR1AL,R16	;PWM=0 OC1A=L

		OUT	OCR1BH,R16
		OUT	OCR1BL,R16	;PWM=0 OC1B=L

		LDI	R16,0b00100001
		OUT	TCCR1A,R16	;Non-invert 8bit PWMA, PWMB 
					;7:6 00 => OC1A not connected
					;    01 => OC1A not connected
					;    10 => OC1A non-inverted PWM
					;    11 => OC1A inverted PWM
					;5:4 00 => OC1B not connected
					;    01 => OC1B not connected
					;    10 => OC1B non-inverted PWM
					;    11 => OC1B inverted PWM
					;1:0 00 => PWM Disabled
					;    01 =>  8 bit PWM
					;    10 =>  9 bit PWM
					;    11 => 10 bit PWM


		LDI	R16,0b00000010
		OUT	TCCR1B,R16	;Input Capture Dis., f=CLK/8
					;7. = 0 Input Capture Noise Canceller Disabled
					;6. = 0 InputCapture ICP Falling edge
					;3. = 1 Reset TC1 when copare match
					;2:0 Clock select
					;   000 => TC1 Stop
					;   001 => Ck
					;   010 => Ck/8
					;   011 => Ck/64
					;   100 => Ck/256
					;   101 => Ck/1024
					;   110 => External T1 Falling Edge
					;   111 => External T1 rising Edge

		CBI	LCDBackLightPort,LCDBackLight
		SBI	LCDBackLightDIR,LCDBackLight		;PWMA kimenet, de nem PWMkent kezeljuk, PWMB mindig kimenet
		ret		
	

;**********************************************
;* HW Timer0 Int
;**********************************************
;* 
TIM0_OVF:	PUSH	ZL
		PUSH	ZH
		IN	ZL,SREG
		PUSH	ZL

		LDI	ZL,T0Freq
		OUT	TCNT0,ZL

		LDD	ZL,Y+SCNT1+0-RAMSTRT			;Software Timer1
		LDD	ZH,Y+SCNT1+1-RAMSTRT
		OR	ZL,ZH
		BREQ	TIM_00
		LDD	ZL,Y+SCNT1+0-RAMSTRT
		SBIW	ZL,1
		STD	Y+SCNT1+0-RAMSTRT,ZL
		STD	Y+SCNT1+1-RAMSTRT,ZH

TIM_00:		LDD	ZL,Y+SCNT2+0-RAMSTRT			;Software Timer2
		LDD	ZH,Y+SCNT2+1-RAMSTRT
		OR	ZL,ZH
		BREQ	TIM_01
		LDD	ZL,Y+SCNT2+0-RAMSTRT
		SBIW	ZL,1
		STD	Y+SCNT2+0-RAMSTRT,ZL
		STD	Y+SCNT2+1-RAMSTRT,ZH

TIM_01:		LDD	ZL,Y+SWTmr0-RAMSTRT			;8 bites SW Timer
		tst	ZL
		breq	TIM_02
		dec	ZL
		STD	Y+SWTmr0-RAMSTRT,ZL


TIM_02:




TIM_0E:		POP	ZL
		OUT	SREG,ZL
		POP	ZH
		POP	ZL
		RETI


TIM1_CAPT:	RETI
TIM1_COMPA:	RETI
TIM1_COMPB:	RETI
TIM1_OVF:	RETI
SPI_STC:	RETI 
EPR_INT:	RETI
ACI_INT:	RETI


