;***************************************************************************
;
; File Name		:'terminal.asm"
; Title			:RS-232 Terminal
; Date			:2001.12.26.	Lastmod.:[2002.10.28.]
; Version		:1.0.0
; Support telephone	:+36-70-333-4034
; Support fax		:
; Support Email		:info@vfx.hu
; Target MCU		:AT90S8515
;
;***************************************************************************
;	D E S C R I P T I O N
;
;  RS-232 alapu terminal
;
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who  why
;	----	----------  ---	--------------------------------------------
;	0.01	2001.12.26  VFX	Creation
;
;***************************************************************************
;Hardware
;***************************************************************************
;*


;**************************************************************************
;* Const Def

.equ	CMD_Buffer_Length = 16

.equ	Term_Echo_Mode	= 0b00000001		;Terminal loopback mode teszthez
						;ami bejott ki is megy
.equ	Term_Rec_Xmodem	= 0b00000010		;Terminal XMODEM Receive mode

;***************************************************************************
.DSEG

CMD_Len:	.byte 1			;a CMD aktualis hossza
CMD_Pos:	.byte 1			;Curzor pozicio a CMD stringen belul
CMD_Data:	.byte CMD_Buffer_Length	;CMD buffer 'string'
Term_Stat:	.byte 1			;Terminal status


;*************************************************************************
;*  Text Const
;*
.CSEG



Init_Term:	clr	R16			;normal Terminal munkodes
;		ori	R16,Term_Echo_Mode	;MOST TESZT MUKODES VAN!!
		sts	Term_Stat,R16
		ret


;*********************************************
; Terminal, Main

Terminal:
		lds	R16,Term_Stat
		andi	R16,Term_Rec_Xmodem	;XMODEM Mode Receive
		breq	Term01
		rjmp	Xmodem_Rec		;Itt Xmodem modban vagyunk

Term01:		rcall	Rs232GetByte
		brcs	Term1
		ret

Term1:		lds	R17,Term_Stat
		andi	R17,Term_Echo_Mode	;TEST mode
		breq	Term1_2


		mov	R16,R0 		;itt echo modban vagyunk R0-t egybol kuldjuk vissza
Term1_4:	rcall	SendChrW
		brcs	Term1_4		;nincs eleg hely
		rjmp	Terminal



Term1_2:	mov	R16,R0		;Normal terminal mode
		cpi	R16,$7b		;<'z'
		brcc	Term2
		cpi	R16,$61		;<'a'
		brcs	Term2
		CBR	R16,32		;kisbetu -> NAGYBETU konverzio!!

Term2:		mov	R0,R16		;csak nagybetu jo!!!!!
		cpi	R16,CR		;Enter?
		breq	Term3		;IGEN -> Parancsfeldolgozas
		cpi	R16,LF		;Line feed?
		breq	Term3
		cpi	R16,DLE		;Delete?
		breq	CMDDelChar


		rcall	PutCharToCMD
                brcc	Terminal
		rcall	CMDTooLong	;Command to long!
		sec
		rjmp	CMDExit

Term3:		rcall	PutCharToCMD
                brcc	CMDProc1
		rcall	CMDTooLong	;Command to long!
		sec
		rjmp	CMDExit

CMDProc1:	rjmp	CMDProcess	;Command line Process


CMDDelChar:                     	;Charakter torles
					;ne ez meg nincs megirva
		rjmp	Terminal


;******************************
;* Put char to CMD buffer
;* In: R0 - char
;* Out c=1 no more space

PutCharToCMD:	ldi	ZL,Low(CMD_Data)
		ldi	ZH,High(CMD_Data)
		clr	R1
		LDS	R16,CMD_Pos		;Command Line Curs Pos
		lds	R17,CMD_Len		;Command Line Lenght
		cpi	R17,CMD_Buffer_Length
		brsh	P_err			;Pos>=CMD_Buffer_Length, nincs tobb hely
		cp	R16,R17
		brne	OverWrite		;Ha pos<>Len, akkor feluliras!

		add	ZL,R17
		adc	ZH,R1
		inc	R17
		rjmp	WriteCMD

OverWrite:	add	ZL,R16
		adc	ZH,R1

WriteCMD:	st	Z,R0
		sts	CMD_Len,R17
		inc	R16
		sts	CMD_Pos,R16		;uj pozicio eltarolasa
		clc				;nincs hiba sima tarolas volt
		ret

P_err:		sec				;hiba tarolas nincs
		ret




ESCSpace:	ld	R16,X+
		cpi	R16,' '			;Space kimarad
		breq	ESCSpace
		cpi	R16,HT
		breq	ESCSpace		;horiz.tab is kimarad
		ret



CMDProcess:	ldi	XL,Low(CMD_Data)
		ldi	XH,High(CMD_Data)

		ldi	ZL,Low(Tm_Commands*2)
		ldi	ZH,High(Tm_Commands*2)	;Parancstablazat cime

LeaderZero:	rcall	ESCSpace
		cpi	R16,LF
		breq	LeaderZero		;Line feed is kimarad


		sbiw	XL,1

		mov	R4,XL
		mov	R5,XH			;elmentjuk az elso ertekes karakter cimet


nextCMD:	lpm
		adiw	ZL,1
		tst	R0			;lehivjuk a tabla kovetkezo lelemet
		brne	VanMegCMD		;ha 0, akkor nincs ilyen parancs
		rjmp	CMDUnk			;ismeretlen parancs hibauzenet

VanMegCMD:	ld	R16,X+			;parancs kovetkezo karaktere
		cp	R16,R0
		brne	Nemstimmel
		lpm
		adiw	ZL,1			;kovetkezo karakter a stringen
		tst	R0
		brne	VanMegCMD

						;PARANCS megvan!!!
		adiw	ZL,1			;tablaban a szoveg vegere ertunk
		andi	ZL,254			;tehat jo a parancs
		lpm				;Z-t eltoljuk a vegrehajto rutin cimehez
		push	R0
		adiw	ZL,1
		lpm
		push	R0			;STACKban vegrehajto rutin cime
		mov	ZL,XL
		mov	ZH,XH			;Z reg a parancs tobbi resze
		ret				;Ugras a vegrehajto reszre


Nemstimmel:	mov	XL,R4			;itt kell eldonteni miert nem stimmel
		mov	XH,R5			;pointer visszaallitasa

SrchStr:	lpm
		adiw	ZL,1			;megkeressuk a sztring veget
		tst	R0
		brne	SrchStr
		adiw	ZL,1
		andi	ZL,254			;csak a paros cim jo
		adiw	ZL,2			;kovetkezo sztring elejere allunk
		rjmp	nextCMD







;********************************************************
; TERMINAL PARANCSOK VEGREHAJTASA
;********************************************************


;***********************************
;  Print DSP IOP Reg
;
Tm_PrintReg:
		rcall	Get2Digit
		brcs	SyntErr1
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr1
		rcall	SendIOP
		rjmp	CMDDone


;***********************************
; Put DSP HBR = parameter 1,0
;
Tm_BootMode:
		rcall	GetHexDigit
		brcs	SyntErr1
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr1
		rcall	SetHBR
		rjmp	CMDOk


;***********************************
; Print DSP HBG status = parameter -
;
Tm_PrintStatus:	rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		breq	Tm_Prn1
        	rjmp	SyntErr
Tm_Prn1:	rcall	PrintStatus
		rjmp	CMDDone


;***********************************
; Send Board Serial Number
;
Tm_Serial:
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr1
		rcall	SendSerialNum
		rjmp	CMDDone


;***********************************
; Put board to reset  RESET = parameter 1,0
;
Tm_Reset:
		rcall	GetHexDigit
		brcs	SyntErr1
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr1
		rcall	SetReset
		rjmp	CMDOk


;***********************************
; Veszkor kezelese parameter 1,0
;
Tm_Vesz:
		rcall	GetHexDigit
		brcs	SyntErr1
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr1
		rcall	SetVesz
		rjmp	CMDOk

SyntErr1:	rjmp	SyntErr


;***********************************
; Set Time parameter Too:pp:mm

Tm_SetTm:	rcall	ESCSpace		;SPACE kihagy
		sbiw	XL,1
		mov	ZL,XL
		mov	ZH,XH


		ldi	XL,Low(Time)		;set Time
		ldi	XH,High(Time)

		ldi	R17,3
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ldi	R17,10
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ld	R16,Z+
		cpi	R16,CR
		breq	Tm_SetDTerr
		cpi	R16,':'
		brne	Tm_SetDTerr
		st	X+,R16

		ldi	R17,6
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ldi	R17,10
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ld	R16,Z+
		cpi	R16,CR
		breq	Tm_SetDTerr
		cpi	R16,':'
		brne	Tm_SetDTerr
		st	X+,R16

      		ldi	R17,6
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ldi	R17,10
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ld	R16,Z+
		cpi	R16,CR
		brne	Tm_SetDTerr


		ldi	ZL,low(RTC_SetTime)
		ldi	ZH,high(RTC_SetTime)
		icall

		rjmp	CMDOk

Tm_SetDTerr:	rjmp	SyntErr



;***********************************
; Set Date parameter Dee:hh:nn


Tm_SetDt:	rcall	ESCSpace		;SPACE kihagy
		sbiw	XL,1
		mov	ZL,XL
		mov	ZH,XH

		ldi	XL,Low(Date+2)		;set Date
		ldi	XH,High(Date+2)

		ldi	R17,10
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ldi	R17,10
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ld	R16,Z+
		cpi	R16,CR
		breq	Tm_SetDTerr
		cpi	R16,'-'
		brne	Tm_SetDTerr
		st	X+,R16

		ldi	R17,2
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ldi	R17,10
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ld	R16,Z+
		cpi	R16,CR
		breq	Tm_SetDTerr
		cpi	R16,'-'
		brne	Tm_SetDTerr
		st	X+,R16

      		ldi	R17,4
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ldi	R17,10
		rcall	Tm_SetDTchk
		brcs	Tm_SetDTerr
		st	X+,R16
		ld	R16,Z+
		cpi	R16,CR
		brne	Tm_SetDTerr			;R0,R1,R2=ev,ho,nap

		ldi	ZL,Low(RTC_SetDate)
		ldi	ZH,High(RTC_SetDate)
		icall
		rjmp	CMDOk




CMDUnk:		rcall	CMDUnknown
		sec
		rjmp	CMDExit

SyntErr:	rcall	SyntaxErr
		sec
		rjmp	CMDExit

CMDOK:		rcall	CMDOkMsg
CMDDone:	clc
CMDExit:	clr	R16
		sts	CMD_Len,R16
		sts	CMD_Pos,R16		;alaphelyzet
		ret




;******************************************
;** E R R O R S
;*******************************************

;******************************************
; Command Too Long massege

CMDTooLong:	ldi	R16,Low(LongCMD*2)
		ldi	R17,High(LongCMD*2)
		rjmp	SendError

;******************************************
; Command Too Long massege

CMDUnknown:   	ldi	R16,Low(UnknownCMD*2)
		ldi	R17,High(UnknownCMD*2)
		rjmp	SendError



;******************************************
; Syntax Error massege

SyntaxErr:   	ldi	R16,Low(StxErr*2)
		ldi	R17,High(StxErr*2)
		rjmp	SendError


CMDOkMsg:   	ldi	R16,Low(CMDAck*2)
		ldi	R17,High(CMDAck*2)
		rjmp	SendMSG


SendError:	push	R16
		push	R17
		ldi	R16,Low(Errx*2)
		ldi	R17,High(Errx*2)
		rcall	SendStrW
		pop	R17
		pop	R16
SendMSG:	rcall	SendStrW
		ret


;***********************************
; Get Time parameter

Tm_GetT:
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		breq	Tm_GetTime1
		rjmp	SyntErr

Tm_GetTime1:	rcall	Tm_GetTime
		rjmp	CMDDone


;***********************************
; Get Date parameter

Tm_GetD:
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		breq	Tm_GetDate1
		rjmp	SyntErr

Tm_GetDate1:	rcall	Tm_GetDate
		rjmp	CMDDone



Tm_GetDate:	ldi	ZL,Low(RTC_GetDate)
		ldi	ZH,High(RTC_GetDate)
		icall
		ldi	XL,Low(Date)
		ldi	XH,High(Date)
		ldi	R22,10
		rjmp	Tm_GetDTc

Tm_GetTime:	ldi	ZL,Low(RTC_GetTime)
		ldi	ZH,High(RTC_GetTime)
		icall
		ldi	XL,Low(Time)
		ldi	XH,High(Time)
		ldi	R22,8
Tm_GetDTc:	rcall	DumpASCII
		ldi	R16,CR
		rcall	SendChrW
		ret


Tm_SetDTchk:	ld	R16,Z+
		cpi	R16,CR
		breq	Tm_Setchkerr
		subi	R16,'0'
		brcs	Tm_Setchkerr
		cp	R16,R17
		brsh	Tm_Setchkerr
		clc
		ret
Tm_Setchkerr:	sec
		ret



SyntErr2:	rjmp	SyntErr



;***********************************
;  Write DSP IOP Reg
; W ii,xxxxxxxx

Tm_Write:
		rcall	Get2Digit
		mov	R8,R0
		brcs	SyntErr2
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,','
		brne	SyntErr2


		rcall	Get2Digit
		mov	R1,R0
		brcs	SyntErr2


		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr2
		mov	R0,R8
		rcall	WriteIOP

Tm_ures:	rjmp	CMDOk


SyntErr3:	rjmp	SyntErr


;*************************************************
;** XMODEM kezelese
;** DSP BOOT file letoltese
;
Tm_BOOT:
		rcall	ESCSpace			;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr3
		ldi	R16,1
		sts	XmodemMode,R16			;DSP Boot Mode

		lds	R16,Term_Stat
		ori	R16,Term_Rec_Xmodem		;Terminal:XMODEM Mode
		sts	Term_Stat,R16

		rcall	Init_Xmodem
		rcall	Init_DSPHostBoot   		;DSP Host mode-ba kapcsolasa + RESET stb.

Tm_xmodem1:	ldi	R16,Low(Xmodemt*2)
		ldi	R17,High(Xmodemt*2)
		rcall	SendMSG
		rjmp	CMDDone


;****************************************
;** TERMINAL HELP
;**
;
Tm_Help:
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr3

		ldi	R16,Low(HelpStr*2)
		ldi	R17,High(HelpStr*2)
		rcall	SendStrW
		rjmp	CMDDone





;***********************************************
;* LCD Hattervilagitas ki/be kapcsolasa

Tm_LCDBackLight:
		rcall	GetHexDigit
		brcs	SyntErr3
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr3

		tst	R0
		breq	Tm_LCDB1
		sbi	LCDBackLightPort,LCDBackLight
		rjmp	CMDOk
Tm_LCDB1:	cbi	LCDBackLightPort,LCDBackLight
		rjmp	CMDOk

;****************************************
;* PWM allitas az X05-n

Tm_PWM:
		rcall	Get2Digit
		brcs	SyntErr3
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr3

		ldi	R16,0
		OUT	OCR1BH,R16
		OUT	OCR1BL,R0	;PWM=xx

		rjmp	CMDOk

;****************************************
;* ICA SWStat olvasasa

Tm_SWStat:
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr3

		lds	R0,SWSTATA
		mov	R16,R16			;Bug miatt
		rcall	PrintBIN

		rjmp	CMDDone


;*************************************
;* Data & CMD kiirasa a DSPbe
; DSPCMD Data,CMD

Tm_DSPCmd:
		rcall	Get2Digit
		brcs	SyntErr4
		mov	R8,R0
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,','
		brne	SyntErr4
		rcall	Get2Digit
		rcall	ESCSpace		;SPACE kihagy
		cpi	R16,CR
		brne	SyntErr4

		sts	DSPDATA,R8
		mov	R8,R8
		sts	DSPADDCMDA,R0
		mov	R0,R0

		rjmp	CMDOk

SyntErr4:	rjmp	SyntErr


;*******************************
;* xx 2 hexa digitet keres X reg a pointer
;* ha c=0, R0 - a parameter
;*    c=1, syntax error

Get2Digit:
		rcall	ESCSpace		;SPACE kihagy
		rcall	TstHexDigit
		brcs	SyntErrhh
		swap	R16
		andi	R16,0xF0
		mov	R0,R16

		ld	R16,X+
		rcall	TstHexDigit
		brcs	SyntErrhh
		andi	R16,0x0F
		or	R0,R16
		clc
		ret
SyntErrhh:	sec
		ret

;*************************************
;* Get digit 0..1
;* c=0, R0=0..1
;* c=1, syntax or overflow error
GetHexDigit:
		rcall	ESCSpace		;SPACE kihagy
		subi	R16,'0'
		brcs	SyntErrGH
		cpi	R16,2
		mov	R0,R16
		brcc	SyntErrGH		;Pramerer 0..1 lehet
		clc
		ret

SyntErrGH:	sec
		ret




;---------------------------------------------------------------------------


HelpStr:	.db	"MAGOR Terminal Help",CR
		.db	"Phh - hh Hex 00..FF kirja a DSP IOP regiszteret",CR
		.db	"Bx  - x=0..1 HBR vonal allapota",CR
		.db	"      0 - HBR low, host mode ",CR
		.db	"      1 - HBR hi, normal uzem",CR
		.db	"I   - Status allpotat irja ki",CR
		.db	"      0. HBG allapota",CR
		.db	"      1. RESET allapota",CR
		.db	"      2. AVRA Veszkor",CR
		.db	"      3. DSP Veszkor ",CR
		.db	"      4. 24V input allapota",CR
		.db	"N   - Sorozat szamot irja ki ",CR
		.db	"Rx  - x=0..1 Reset board ",CR
		.db	"Vx  - x=0..1 Veszkor kezelese",CR
		.db	"ST oo:pp:mm - beallitja az idot",CR
		.db	"SD ee:hh:nn - beallitja a datumot",CR
		.db	"GT - lekerdezi az idot ",CR
		.db	"GD - lekerdezi a datumot ",CR
		.db	"Wii,xxxxxxxx - ii DSP IOP regiszterbe irja xx HEX erteket",CR
		.db	"BOOT - XMODEM Bootfile letoltes a DSPbe",CR
		.db	"H vagy HELP - ezt a helpet adja",CR
		.db	"LCDx - x=0..1 LCD hatterfeny ki/be ",CR
		.db	"PWM xx xx=00..FF Analog PWM/Zummer ",CR
		.db	"SWSTAT - Software status kiiratasa ",CR
		.db	"DSPCMD Data,Cmd - Data & Command kuldese a DSPbe ",CR
		.dw	0




ECopyr:	  .DB "(C) 2001,2002 MAGOR CP01-1v2 Terminal Interface [2001.12.24.]",CR
	  .DB "Firmware version ",MAJOR_REV,".",MINOR_REV,MINOR_REVB," "
	  .DB "Latest Upd.: 2002.12.18. ",CR
	  .DB "MagTerm by VFX [info@vfx.hu] ",CR
	  .DB "Board S/N: ",0
ECD:	  .DB "Current Date:  ",0
ECT:	  .DB "Current Time:  ",0


;Ready:		.DB	"Ready>>",0
CMDAck: 	.DB	"Ok.",CR,0,0
Errx:		.DB	"Error:",0,0
LongCMD:	.DB	" Command too long",CR,0,0
UnknownCMD:	.DB	" Unknown Command",CR,0
kbTimeOutErr:	.db	"Keyboard error... ",CR,0
ps2stszov:	.db	"PS/2 keyboard found.",CR,0
magorszov:	.db	"MAGOR HI-01 keyboard found. ",CR,0
StxErr:		.DB	" Syntax Error",CR,0,0
SearchKeyb:	.DB	"Scanning keyboard... ",0
Xmodemt:	.DB	"XMODEM listening... ",0,0


;Terminal parancsok
; "parancs",0,address
; a tabla elso eleme mindig az ures parancs legyen ures sor+ENTER

Tm_Commands:	.db	CR,0,low(Tm_ures),high(Tm_ures)
		.db	"PWM",0,low(Tm_PWM),high(Tm_PWM)
		.db	"P",0,low(Tm_PrintReg),high(Tm_PrintReg)
		.db	"BOOT",0,0,low(Tm_Boot),high(Tm_Boot)
		.db	"B",0,low(Tm_BootMode),high(Tm_BootMode)
		.db	"I",0,low(Tm_PrintStatus),high(Tm_PrintStatus)
		.db	"N",0,low(Tm_Serial),high(Tm_Serial)
		.db	"R",0,low(Tm_Reset),high(Tm_Reset)
		.db	"V",0,low(Tm_Vesz),high(Tm_Vesz)
		.db	"SWSTAT",0,0,low(Tm_SWStat),high(Tm_SWStat)
		.db	"ST",0,0,low(Tm_SetTm),high(Tm_SetTm)
		.db	"SD",0,0,low(Tm_SetDt),high(Tm_SetDt)
		.db	"GT",0,0,low(Tm_GetT),high(Tm_GetT)
		.db	"GD",0,0,low(Tm_GetD),high(Tm_GetD)
		.db	"W",0,low(Tm_Write),high(Tm_Write)
		.db	"HELP",0,0,low(Tm_Help),high(Tm_Help)
		.db	"H",0,low(Tm_Help),high(Tm_Help)
		.db	"LCD",0,low(Tm_LCDBackLight),high(Tm_LCDBackLight)
		.db	"DSPCMD",0,0,low(Tm_DSPCmd),high(Tm_DSPCmd)
		.dw	0

