;***************************************************************************
;
; File Name		:'user.asm"
; Title			:Altalanos felhasznaloi rutinok
; Date			:2001.12.30.	Lastmod.:[2002.10.28.]
; Version		:1.0.1
; Support telephone	:+36-30-9541-658 VFX
; Support fax		:+36-30-9809-372
; Support Email		:info@vfx.hu
; Target MCU		:AT90S8515
;
;***************************************************************************
;	D E S C R I P T I O N
;
;
;
;
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who  why
;	----	----------  ---	--------------------------------------------
;	0.01	2001.12.30  VFX	Creation
;
;***************************************************************************
;
;
;
;Hardware
;***************************************************************************
;*



;**************************************************************************
;* Const Def



;***************************************************************************
.DSEG


;*************************************************************************
;*  Code
;*
.CSEG


;********************************
; 8 byte-ot HEX alakban kiir a sorosportra X-regtol kezdve
; In:	X - address
;
;

HexDump:	ldi	R21,8
		clr	XL
		clr	XH
HexDump1:	rcall	DumpRow
		dec	R21
		brne	HexDump1
		ret



;****************************
;* Memoria DUMP 1 sorras X-tol kezdve
;
DumpRow:	mov	R0,XH
		rcall	HexToUART		;Cim H-byte
		mov	R0,XL
		rcall	HexToUART		;L-byte
		ldi	R16,' '
		rcall	SendChrW
		push	XL
		push	XH

		rcall	DumpHalfRow
		ldi	R16,'|'
		rcall	SendChrW
		rcall	DumpHalfRow
		ldi	R16,'|'
		rcall	SendChrW
		ldi	R16,' '
		rcall	SendChrW

		pop	XH
		pop	XL

		ret


;********************************
; 8 byte-ot hex alakban kiir a sorosportra X-regtol kezdve
;
DumpHalfRow:	ldi	R22,8
DumpR0:		ld	R0,X+
		rcall	HexToUART
		ldi	R16,' '
		rcall	SendChrW
		dec	R22
		brne	DumpR0
		ret



Init_DSPHostBoot:
		ldi	R16,0
		sts	RegRES,R16		;DSP es az egesz panel resetbe kuldese
		ldi	ZL,low(65535)
		ldi	ZH,high(65535)
IDHB1:		sbiw	ZL,1
		brne	IDHB1			;itt legalabb 35.5ms varakozas, hogy mindeki restbe legyen


		;itt majd be kell alllitani, hogy aa DSP Host modeban induljon ujjra



		ldi	R16,1
		sts	RegRES,R16		;DSP es az egesz panel reset elengesdese, hadmenjen
		ldi	ZL,low(65535)
		ldi	ZH,high(65535)
IDHB2:		sbiw	ZL,1
		brne	IDHB2			;itt legalabb 35.5ms varakozas, hogy mindeki kijohessen a restbol


		ldi	R16,0
		sts	ICACMD,R16		;HBR=0
		ldi	R16,0x04		;mert nop nem alhat az sts utan kozvetlenul
		nop				;R16=0x04 = EPB0 DMA regiszter cime
		nop
		nop
		sts	DSPADDCMDA,R16		;EPB0 IOP Register
		ret				;innen johet a file letoltes

;***********************************
;  DSP Boot Process
;  R16- hany byte-ot lehet bootoltatni X-regtol kezdve

Usr_DSPBoot:	ld	R0,X+
		sts	DSPDATA,R0
		mov	R0,R0			;sts,lds utan nem lehet nop

						;itt elengedjuk a Host bust, hogy a DSP
						;tudjon a kulso memoriaba irni, ha akar
		push	R16
		ldi	R16,1
		sts	ICACMD,R16		;Bus elengedve
		mov	R16,R16
		eor	R0,R0
DSPfogja:	inc	R0			;[1]	ha megsem valaszolna kilepes
		tst	R0			;[1]
		breq	Timeover1		;[1]
		nop				;[1]
		lds	R16,STATA		;[2] ciklus mig el nem engedi a DSP
		mov	R16,R16			;[1]
		andi	R16,1			;[1]
		breq	DSPfogja		;[2]
                                		;itt bus elengedve
		ldi	R16,50
loop11:		dec	R16
		brne	loop11			;kis varakozas utan visszakerjuk a buszt!


		ldi	R16,0
		sts	ICACMD,R16		;Bus keres
		mov	R16,R16

		eor	R0,R0
DSPvalszolt:	inc	R0			;[1]	ha megsem valaszolna kilepes
		tst	R0			;[1]
		breq	Timeover1		;[1]
		nop				;[1]

	        lds	R16,STATA		;ciklus mig DSP nem adja oda a buszt
		mov	R16,R16
		andi	R16,1
		brne	DSPvalszolt
		nop

		pop	R16			;mehet tovabb
		dec	R16
		brne	Usr_DSPBoot
		ret

Timeover1:	pop	R16
		ret






Usr_DSPFill:	ldi	R17,0x1A
		sts	DSPDATA,R17
		mov	R0,R0
		nop
		nop
		dec	R16
		brne	Usr_DSPFill
		ret



sokatvar:	Ldi	R19,7
skvar:		ldi	R20,0
skvar1:		dec	R20
		brne	skvar1
		dec	R19
		brne	skvar
		ret


;************************************
; HBR vonal kezelese
; R0: HBR vonal allapota 0 - HBR aktiv
;			 1 - HBR inaktiv
; Parameter ellenorzotten 0 vagy 1 lehet!!!!

SetHBR:		sts	ICACMD,R0	;MACH-ba kuldese
		mov	R0,R0
		ret


;************************************
; Status allapotat irja ki
;
;STATA
; 0. HBG allapota
; 1. RESET allapota
; 2. AVRA Veszkor
; 3. DSP Veszkor
; 4. 24V input allapota
; 5. -
; 6. -
; 7. -

PrintStatus:	lds	R0,STATA
PrintBIN:	rcall	BinToUART
		ldi	R16,CR
		rcall	SendChrW
		ret



;************************************
; Send DSP IOP Register
;  Hivas elott HBR=0 kell legyen,kulonben a DSP AVRA adatregisytert olvassa!!
;
;  R0 - IOP Address

SendIOP:	sts	DSPADDCMDA,R0
		inc	R0
		dec	R0			;bug miatt sts utan nem lehet nop!!
		nop				;hogy tutira HBG=0 legyen

		ldi	R16,'0'
		rcall	SendChrW
		ldi	R16,'x'
		rcall	SendChrW

		lds	R0,DSPDATA
		push	R0
		lds	R0,DSPDATA
		push	R0
		lds	R0,DSPDATA
		push	R0
		lds	R0,DSPDATA

		rcall	HexToUART
		pop	R0
		rcall	HexToUART
		pop	R0
		rcall	HexToUART
		pop	R0
		rcall	HexToUART

		ldi	R16,CR
		rcall	SendChrW
		ret


;************************************
; Write DSP IOP Register
;  Hivas elott HBR=0 kell legyen,kulonben a DSP AVRA adatregisztert irja!!
;
;  R0 - IOP Address, R1 data

WriteIOP:	sts	DSPADDCMDA,R0
		mov	R0,R0			;nop nem lehet itt, bug fix
		sts	DSPDATA,R1		;data
		inc	R1
		sts	DSPDATA,R1
		inc	R1
		sts	DSPDATA,R1
		ldi	R16,12
		sts	DSPDATA,R16
		ret

;************************************
; Send SerialNumber of Board

SendSerialNum:
		lds	R0,SerialNumHH		;Serial Number MSB
         	rcall	HexToUART
		lds	R0,SerialNumHL
         	rcall	HexToUART
		lds	R0,SerialNumLH
         	rcall	HexToUART
		lds	R0,SerialNumLL		;Serial Number LSB
         	rcall	HexToUART
		ldi	R16,CR
		rcall	SendChrW
		ret



;************************************
; RESET vonal kezelese
; R0:  vonal allapota    0 - RESET
;			 1 - Normal uzem
; Parameter ellenorzotten 0 vagy 1 lehet!!!!

SetReset:	sts	RegRES,R0	;MACH-ba kuldese
		ret

SetVesz:	sts	RegVesz,R0	;MACH-ba kuldese
		ret



TstHexDigit:	cpi	R16,'0'
		brcs	tstherr
		cpi	R16,'9'+1
		brcs	digitnekjo

		cpi	R16,'a'
		brcs	botu
		subi	R16,32
botu:
        	cpi	R16,'A'
		brcs	tstherr
                cpi	R16,'F'+1
		brsh	tsthexok

		subi	R16,7
digitnekjo:	subi	R16,'0'
tsthexok:	clc
		ret
tstherr:	sec
		ret
